(in-package :maisql-mysql)

(defparameter *mysql-default-blob-length* "512")

(defmethod database-get-type-specifier
  (type args (database mysql-database))
  (declare (ignore type args))
  "BLOB")

(defmethod database-get-type-specifier
  ((type (eql 'integer)) args (database mysql-database))
  (if args
      (format nil "BIGINT"
	      (or (first args) 38) (or (second args) 0))
    "BIGINT"))

(defmethod database-get-type-specifier
  ((type (eql 'simple-base-string)) args (database mysql-database))
   (declare (ignore type args))
  "BLOB")

(defmethod database-get-type-specifier
  ((type (eql 'simple-string)) args (database mysql-database))
 (declare (ignore type args))
  "BLOB")


(defmethod database-get-type-specifier
  ((type (eql 'string)) args (database mysql-database))
 (declare (ignore type args))
  "BLOB")


(defmethod database-get-type-specifier
  ((type (eql 'raw-string)) args (database mysql-database))
 (declare (ignore type args))
  "BLOB")


(defmethod database-get-type-specifier
  ((type (eql 'float)) args (database mysql-database))
  (if args
      (format nil "BIGINT"
	      (or (first args) 38) (or (second args) 38))
    "BIGINT"))

(defmethod database-get-type-specifier
  ((type (eql 'long-float)) args (database mysql-database))
  (if args
      (format nil "BIGINT"
	      (or (first args) 38) (or (second args) 38))
    "BIGINT"))

(defmethod read-sql-value (val type (database mysql-database))
  (declare (ignore type database))
  ;;(format t "value is \"~A\" of type ~A~%" val (type-of val))
  (etypecase val
    (string
     (read-from-string val))
    (symbol
     nil)))

(defmethod read-sql-value (val (type (eql 'string)) database)
  (declare (ignore database))
  val)

(defmethod read-sql-value
  (val (type (eql 'integer)) (database mysql-database))
  (declare (ignore database))
  val)

(defmethod read-sql-value (val (type (eql 'float)) (database mysql-database))
  val)

;;; odcl TIME stuff that needs to go into hooks

(defmethod maisql-sys::database-get-type-specifier
  ((type (eql 'wall-time)) args (database mysql-database))
  (declare (ignore args))
  "DATETIME")
